<?php

class Admin extends Controller {

    function Admin() {
        parent :: Controller();
        $this->load->model('adminmodel');
    }

    function index() {
        redirect('admin/login');
    }

    function login() {
        $message = "";
        $data['formTable'] = $this->_generatelogin($message);
        $data['formOpen'] = form_open('admin/loginform');
        $data['title'] = 'CTFS Generic Data Entry';
        $data['contentTitle'] = 'Admin Menu';
        $this->load->view('admin/loginform', $data);
    }

    function loginform() {
        $passCode = "b11f562b3e89e1e4c5ab82f3dd3055fd";
        $pwd = $this->input->post('password');
        $pwdMD5 = md5($pwd);
        if ($passCode == $pwdMD5) {
            $this->session->set_userdata('admin', 'yes');
            redirect('admin/menu');
        }
        else {
            $message = '<p class="errorblock">Invalid Password</p>';
            $data['formTable'] = $this->_generatelogin($message);
            $data['formOpen'] = form_open('admin/loginform');
            $data['title'] = 'CTFS Generic Data Entry';
            $data['contentTitle'] = 'Admin Menu';
            $this->load->view('admin/loginform', $data);
        }
    }

    function _generatelogin($message) {
        $pwdA = array('name' => 'password', 'id' => 'password', 'size' => '16');
        $pwdTbx = form_password($pwdA);
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $submitButton = form_button($submitButtonA);
        $formTableA = array(array(), array('Password : ', $pwdTbx), array('', $submitButton), array('', $message));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function menu() {
        if ($this->session->userdata('admin') !== 'yes') {
            redirect('admin/login', 'location');
        }
        $data['formTable'] = $this->_generatemenu();
        $data['formOpen'] = "";
        $data['title'] = 'CTFS Generic Data Entry';
        $data['contentTitle'] = 'Admin Menu';
        $this->load->view('admin/mainform', $data);
    }

    function _generatemenu() {
        $formTableA = array(array(), array('Please select an option from Admin Menu.'));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function addplot() {
        if ($this->session->userdata('admin') !== 'yes') {
            redirect('admin/login', 'location');
        }
        $data['formTable'] = $this->_generateaddplot();
        $data['formOpen'] = form_open('admin/addplotform');
        $data['title'] = 'CTFS Generic Data Entry';
        $data['contentTitle'] = 'Add Database Info';
        $this->load->view('admin/mainform', $data);
    }

    function addplotform() {
        $this->_validateaddplotform();
        if ($this->form_validation->run() == FALSE) {
            $data['formTable'] = $this->_generateaddplot();
            $data['formOpen'] = form_open('admin/addplotform');
            $data['title'] = 'CTFS Generic Data Entry';
            $data['contentTitle'] = 'Add Database Info';
            $this->load->view('admin/mainform', $data);
        }
        else {
            $plotName = $this->input->post('plotName');
            $databaseName = $this->input->post('databaseName');
            $databaseVersion = 'New';
            $insertArray = array('PlotName' => $plotName, 'DatabaseName' => $databaseName, 'DatabaseVersion' => $databaseVersion
                                );
            $status = $this->adminmodel->insertPlot($insertArray);
            if ($status = 'success') {
                $data['title'] = 'CTFS Generic Data Entry';
                $data['contentTitle'] = 'Add Database Info';
                $data['message1'] = "<div class='success'>Database Added.</div>";
                $data['message2'] = anchor('admin/addplot', 'Add More Database', 'class="add"');
                $this->load->view('admin/message', $data);
            }
            else {
                $data['title'] = 'CTFS Generic Data Entry';
                $data['contentTitle'] = 'Add Database Info';
                $data['message1'] = "<div class='error'>Error Adding Plot</div>";
                $data['message2'] = anchor('admin/addplot', 'Try Again', 'class="update"');
                $this->load->view('admin/message', $data);
            }
        }
    }

    function _generateaddplot() {
        $plotName = set_value('plotName');
        $databaseName = set_value('databaseName');
        $databaseVersion = set_value('databaseVersion');
        $plotNameA = array('name' => 'plotName', 'id' => 'plotName', 'size' => '16', 'value' => $plotName);
        $databaseNameA = array('name' => 'databaseName', 'id' => 'databaseName', 'size' => '16', 'value' => $databaseName
                              );
        //$databaseVersionA = array('default'=>'Select','new'=>'New','old'=>'Old');
        $plotNameTbx = form_input($plotNameA);
        $databaseNameTbx = form_input($databaseNameA);
        //$databaseVersionDD = form_dropdown('databaseVersion',$databaseVersionA);
        $plotNameErr = form_error('plotName');
        $databaseNameErr = form_error('databaseName');
        //$databaseVersionErr = form_error('databaseVersion');
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $resetButtonA = array('name' => 'resetButton', 'id' => 'button', 'type' => 'reset', 'content' => 'Reset');
        $submitButton = form_button($submitButtonA);
        $resetButton = form_button($resetButtonA);
        $formTableA = array(array(), array('Dropdown Database Name : ', $plotNameTbx, $plotNameErr),
        // array('Database Name : ',$databaseNameTbx,'<span style="color:#FF0000; font-size:8pt;">db name in database.php file</span>'),
        array('Database Group Name In Config File : ', $databaseNameTbx, $databaseNameErr),
        //array('Version of Database : ',$databaseVersionDD,$databaseVersionErr),
        array($submitButton."\t".$resetButton));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validateaddplotform() {
        $this->form_validation->set_rules('plotName', 'Dropdown Database Name', 'trim|required|alpha_numeric');
        $this->form_validation->set_rules('databaseName', 'Database Group Name', 'trim|required|alpha_numeric');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function adduser() {
        if ($this->session->userdata('admin') !== 'yes') {
            redirect('admin/login', 'location');
        }
        $data['formTable'] = $this->_generateadduser();
        $data['formOpen'] = form_open('admin/adduserform');
        $data['title'] = 'CTFS Generic Data Entry';
        $data['contentTitle'] = 'Add User';
        $this->load->view('admin/mainform', $data);
    }

    function adduserform() {
        $this->_validateadduserform();
        if ($this->form_validation->run() == FALSE) {
            $data['formTable'] = $this->_generateadduser();
            $data['formOpen'] = form_open('admin/adduserform');
            $data['title'] = 'CTFS Generic Data Entry';
            $data['contentTitle'] = 'Add User';
            $this->load->view('admin/mainform', $data);
        }
        else {
            $userName = $this->input->post('userName');
            $password = $this->input->post('password');
            $databaseName = $this->input->post('databaseName');
            $password = $this->adminmodel->convertPassword($password);
            $insertArray = array('UserName' => $userName, 'Pwd' => $password, 'databaseName' => $databaseName);
            $status = $this->adminmodel->insertUser($insertArray);
            if ($status = 'success') {
                $data['title'] = 'CTFS Generic Data Entry';
                $data['contentTitle'] = 'Add User';
                $data['message1'] = "<div class='success'>User Added.</div>";
                $data['message2'] = anchor('admin/adduser', 'Add More User', 'class="add"');
                $this->load->view('admin/message', $data);
            }
            else {
                $data['title'] = 'CTFS Generic Data Entry';
                $data['contentTitle'] = 'Add User';
                $data['message1'] = "<div class='error'>Error Adding User</div>";
                $data['message2'] = anchor('admin/adduser', 'Try Again', 'class="update"');
                $this->load->view('admin/message', $data);
            }
        }
    }

    function _generateadduser() {
        $userName = set_value('userName');
        $password = set_value('password');
        $databaseName = set_value('databaseName');
        $userNameA = array('name' => 'userName', 'id' => 'userName', 'size' => '16', 'value' => $userName);
        $passwordA = array('name' => 'password', 'id' => 'password', 'size' => '16', 'value' => $password);
        $databaseNameA = $this->adminmodel->databaseNamesDD();
        $userNameTbx = form_input($userNameA);
        $passwordTbx = form_input($passwordA);
        $databaseNameDD = form_dropdown('databaseName', $databaseNameA, $databaseName);
        $userNameErr = form_error('userName');
        $passwordErr = form_error('password');
        $databaseNameErr = form_error('databaseName');
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $resetButtonA = array('name' => 'resetButton', 'id' => 'button', 'type' => 'reset', 'content' => 'Reset');
        $submitButton = form_button($submitButtonA);
        $resetButton = form_button($resetButtonA);
        $formTableA = array(array(), array('Username : ', $userNameTbx, $userNameErr), array('Password : ', $passwordTbx,
                           $passwordErr), array('Database Name : ', $databaseNameDD, $databaseNameErr), array($submitButton
                           ."\t".$resetButton));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validateadduserform() {
        $this->form_validation->set_rules('userName', 'Username', 'trim|required|alpha_numeric');
        $this->form_validation->set_rules('password', 'Password', 'trim|required|alpha_numeric');
        $this->form_validation->set_rules('databaseName', 'Database Name', 'callback_dropdown_check');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function addlink() {
        if ($this->session->userdata('admin') !== 'yes') {
            redirect('admin/login', 'location');
        }
        $data['formTable'] = $this->_generateaddlink();
        $data['formOpen'] = form_open('admin/addlinkform');
        $data['title'] = 'CTFS Generic Data Entry';
        $data['contentTitle'] = 'Admin Menu';
        $this->load->view('admin/mainform', $data);
    }

    function addlinkform() {
        $this->_validateaddlinkform();
        if ($this->form_validation->run() == FALSE) {
            $data['formTable'] = $this->_generateaddlink();
            $data['formOpen'] = form_open('admin/addlinkform');
            $data['title'] = 'CTFS Generic Data Entry';
            $data['contentTitle'] = 'Admin Menu';
            $this->load->view('admin/mainform', $data);
        }
        else {
            $title = $this->input->post('title');
            $path = $this->input->post('path');
            $date = $this->input->post('date');
            $databaseName = $this->input->post('databaseName');
            $linkType = $this->input->post('linkType');
            $insertArray = array('Title' => $title, 'Path' => $path, 'Date' => $date, 'DatabaseName' => $databaseName,
                                'LinkType' => $linkType);
            $status = $this->adminmodel->insertlink($insertArray);
            if ($status = 'success') {
                $data['title'] = 'CTFS Generic Data Entry';
                $data['contentTitle'] = 'Admin Menu';
                $data['message1'] = "<div class='success'>Link Added.</div>";
                $data['message2'] = anchor('admin/addlink', 'Add More Link', 'class="add"');
                $this->load->view('admin/message', $data);
            }
            else {
                $data['title'] = 'CTFS Generic Data Entry';
                $data['contentTitle'] = 'Admin Menu';
                $data['message1'] = "<div class='error'>Error Adding Link</div>";
                $data['message2'] = anchor('admin/addlink', 'Try Again', 'class="update"');
                $this->load->view('admin/message', $data);
            }
        }
    }

    function _generateaddlink() {
        $title = set_value('title');
        $path = set_value('path');
        $date = set_value('date');
        $databaseName = set_value('databaseName');
        $linkType = set_value('linkType');
        $titleA = array('name' => 'title', 'id' => 'title', 'size' => '20', 'value' => $title);
        $pathA = array('name' => 'path', 'id' => 'path', 'size' => '20', 'value' => $path);
        $dateA = array('name' => 'date', 'id' => 'date', 'size' => '20', 'value' => $date);
        $databaseNameA = $this->adminmodel->databaseNamesDD();
        $linkTypeA = array('default' => 'Select', 'PlotData' => 'PlotData', 'Taxonomy' => 'Taxonomy', 'Archive' =>
                          'Archive');
        $titleTbx = form_input($titleA);
        $pathTbx = form_input($pathA);
        $dateTbx = form_input($dateA);
        $databaseNameDD = form_dropdown('databaseName', $databaseNameA, $databaseName);
        $linkTypeDD = form_dropdown('linkType', $linkTypeA, $linkType);
        $titleErr = form_error('title');
        $pathErr = form_error('path');
        $dateErr = form_error('date');
        $databaseNameErr = form_error('databaseName');
        $linkTypeErr = form_error('linkType');
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $resetButtonA = array('name' => 'resetButton', 'id' => 'button', 'type' => 'reset', 'content' => 'Reset');
        $submitButton = form_button($submitButtonA);
        $resetButton = form_button($resetButtonA);
        $formTableA = array(array(), array('Title: ', $titleTbx, $titleErr), array('Path : ', $pathTbx, $pathErr), array
                           ('Date(mm-dd-yyyy) :', $dateTbx, $dateErr), array('Database Name : ', $databaseNameDD, $databaseNameErr
                           ), array('Link Type : ', $linkTypeDD, $linkTypeErr), array($submitButton."\t".$resetButton));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validateaddlinkform() {
        $this->form_validation->set_rules('title', 'Title', 'trim|required');
        $this->form_validation->set_rules('path', 'Path', 'trim|required');
        $this->form_validation->set_rules('date', 'Date', 'trim|required');
        $this->form_validation->set_rules('databaseName', 'Database Name', 'callback_dropdown_check');
        $this->form_validation->set_rules('linkType', 'Link Type', 'callback_dropdown_check');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function logout() {
        $this->session->unset_userdata('admin');
        redirect('admin/login', 'location');
    }

    function dropdown_check($str) {
        if ($str == 'default') {
            $this->form_validation->set_message('dropdown_check', '%s need to be Selected');
            return FALSE;
        }
        else {
            return True;
        }
    }

}
